program MakeLink;

{$apptype console}

uses
  Windows,
  ShellObj,
  StdCode,
  OLE2,
  SysUtils;

var
  sFrom: String;
  sTo:   String;

{$R *.RES}

function  CreateLink(lpszPathObj: LPCSTR; lpszPathLink: LPSTR; lpszDesc: LPSTR): HRESULT;
var       hRes: HRESULT;
          psl:  IShellLink;
          ppf:  IPersistFile;
          wsz:  PWideChar;
begin
  CoInitialize(NIL);
  hRes:=CoCreateInstance(CLSID_ShellLink, NIL, CLSCTX_INPROC_SERVER, IID_IShellLink, psl);
  if SUCCEEDED(hres) then begin
    psl.SetPath(lpszPathObj);
    psl.SetDescription(lpszDesc);
    hres:=psl.QueryInterface(IID_IPersistFile, ppf);
    if SUCCEEDED(hres) then begin
      wsz:=AllocMem(2*MAX_PATH);
      MultiByteToWideChar(CP_ACP, 0, lpszPathLink, -1, wsz, MAX_PATH);
      hres:=ppf.Save(wsz, TRUE);
      FreeMem(wsz, 2*MAX_PATH);
      ppf.Release;
    end;
    psl.Release;
  end;
  Result:=hRes;
end;

procedure ShellLink(sSrc, sDst: String);
begin
  CreateLink(PChar(sSrc), PChar(ChangeFileExt(sDst, '.lnk')), PChar(ExtractFileName(ChangeFileExt(sDst, '.lnk'))));
end;

procedure Hilfe(sMsg: String);
begin
  Writeln('MakeLink ', GetVerInfo(ParamStr(0)));
  Writeln;
  Writeln('usage: ', LowerCase(ExtractOnlyFileName(ParamStr(0))), ' [/?=?] <src> <dst>');
  Writeln('creates a shortcut from src to dst');
  Writeln;
  if sMsg<>'' then
    Writeln(sMsg);
  Halt;
end;

procedure ParseCLI;
var       sTmp:     String;
          iCounter: Integer;
begin
  sFrom:='';
  sTo:='';
  for iCounter:=1 to ParamCount do begin
    sTmp:=ParamStr(iCounter);
    if (sTmp='?') or (sTmp='/?') then
      Hilfe('');
    if (sTmp[1]<>'/') then
      if sFrom<>'' then
        if sTo<>'' then
          Hilfe('Error: Too many parameters!')
        else
          sTo:=sTmp
      else
        sFrom:=sTmp;
  end;
end;

begin
  ParseCLI;
  ShellLink(sFrom, sTo);
end.
